"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _utils = require("./utils");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var mapValues = function mapValues(values, params, transformValueFn) {
  var paramNames = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  return Object.keys(params).reduce(function (finalParams, paramName) {
    var options = params[paramName];
    var value = values[paramName];
    var paramPath = [].concat(_toConsumableArray(paramNames), [paramName]).join(".");
    var mergeParam = function mergeParam(finalValue) {
      return _extends({}, finalParams, _defineProperty({}, paramName, finalValue));
    };

    if ((0, _utils.isArray)(options.type)) {
      var _options$type = _slicedToArray(options.type, 1),
          opt = _options$type[0];

      var finalValue = (0, _utils.toArray)(value).map(function (val, i) {
        return transformValueFn(val, opt, paramName, [paramPath, i].join("."));
      });
      return mergeParam(finalValue);
    }

    if ((0, _utils.isSchema)(options.type)) {
      return mergeParam(mapValues(value, options.type.params, transformValueFn, [paramPath]));
    }

    return mergeParam(transformValueFn(value, options, paramName, paramPath));
  }, {});
};

exports.default = mapValues;